;IncludeFile "RTask_Inc.pb"
;IncludeFile "RTask_Func.pb"

;RTask_Init()
;-Creates a new task
;{
   Debug RTask_CreateTask("Task Example")
;}
;-Starts a known task
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Test Task.job"
        RTask_Run()
      EndIf
    Wend
  EndIf
;}
; Terminates a known task
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Task Example.job"
        If RTask_GetStatus() = #SCHED_S_TASK_RUNNING
          RTask_Stop()
        EndIf
      EndIf
    Wend
  EndIf

;}
;-Enumerates all the tasks on the local computer
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      Debug RTask_GetJobFileName()
    Wend
  EndIf
;}

;-- Properties
;-Sets properties for an item
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Task Example.job"
        RTask_SetTargetFileName("C:\A\Path\To\An\Exe.exe")
        RTask_SetMaxRunTime(10)
        RTask_SetPriority(#NORMAL_PRIORITY_CLASS)
        RTask_SetWorkingDirectory("C:\A\Path\To\An\")
        RTask_SetParameters("")
        RTask_SetFlags(#TASK_FLAG_DELETE_WHEN_DONE|#TASK_FLAG_START_ONLY_IF_IDLE|#TASK_FLAG_DONT_START_IF_ON_BATTERIES)
        RTask_SetCreator("God")
        RTask_SetComment("Test Comment"+Chr(13)+Chr(10)+"test on the second line")
        RTask_SetAccountInformation("usr1", "arle")
        RTask_SetIdleWait(200,50)
      EndIf
    Wend
  EndIf
;}
;-Get properties of items
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
        Debug "----------------------------"
        Debug "Job : "+RTask_GetJobFileName()
        Debug "----------------------------"
        Debug "Target : "+RTask_GetTargetFileName()
        Debug "Account Information : " + RTask_GetAccountInformation()
        Debug "Comment : "+RTask_GetComment()
        Debug "Creator : "+RTask_GetCreator()
        Debug "ExitCode : "+Str(RTask_GetExitCode())
        Debug "IdleWait : "+Str(RTask_GetIdleWait())
        Debug "LastRunTime : "+FormatDate("%dd/%mm/%yyyy %hh:%ii:%ss",RTask_GetLastRunTime())
        Debug "NextRunTime : "+FormatDate("%dd/%mm/%yyyy %hh:%ii:%ss",RTask_GetNextRunTime())
        Debug "MaxRunTime : "+Str(RTask_GetMaxRunTime())
        Debug "Status : "+Str(RTask_GetStatus())
        Debug "Priority : "
        Debug "     #REALTIME_PRIORITY_CLASS : "+Str(RTask_GetPriority()+#REALTIME_PRIORITY_CLASS)
        Debug "     #HIGH_PRIORITY_CLASS : "+Str(RTask_GetPriority()+#HIGH_PRIORITY_CLASS)
        Debug "     #NORMAL_PRIORITY_CLASS : "+Str(RTask_GetPriority()+#NORMAL_PRIORITY_CLASS)
        Debug "     #IDLE_PRIORITY_CLASS : "+Str(RTask_GetPriority()+#IDLE_PRIORITY_CLASS)
        Debug "Working Directory : "+RTask_GetWorkingDirectory()
        Debug "Parameters : "+RTask_GetParameters()
        Debug "Flags : "
        Debug "     #TASK_FLAG_INTERACTIVE                  "+Str(RTask_GetFlags()&#TASK_FLAG_INTERACTIVE)
        Debug "     #TASK_FLAG_DELETE_WHEN_DONE             "+Str(RTask_GetFlags()&#TASK_FLAG_DELETE_WHEN_DONE)
        Debug "     #TASK_FLAG_DISABLED                     "+Str(RTask_GetFlags()&#TASK_FLAG_DISABLED)
        Debug "     #TASK_FLAG_START_ONLY_IF_IDLE           "+Str(RTask_GetFlags()&#TASK_FLAG_START_ONLY_IF_IDLE)
        Debug "     #TASK_FLAG_KILL_ON_IDLE_END             "+Str(RTask_GetFlags()&#TASK_FLAG_KILL_ON_IDLE_END)
        Debug "     #TASK_FLAG_DONT_START_IF_ON_BATTERIES   "+Str(RTask_GetFlags()&#TASK_FLAG_DONT_START_IF_ON_BATTERIES)
        Debug "     #TASK_FLAG_KILL_IF_GOING_ON_BATTERIES   "+Str(RTask_GetFlags()&#TASK_FLAG_KILL_IF_GOING_ON_BATTERIES)
        Debug "     #TASK_FLAG_RUN_ONLY_IF_DOCKED           "+Str(RTask_GetFlags()&#TASK_FLAG_RUN_ONLY_IF_DOCKED)
        Debug "     #TASK_FLAG_HIDDEN                       "+Str(RTask_GetFlags()&#TASK_FLAG_HIDDEN)
        Debug "     #TASK_FLAG_RUN_IF_CONNECTED_TO_INTERNET "+Str(RTask_GetFlags()&#TASK_FLAG_RUN_IF_CONNECTED_TO_INTERNET)
        Debug "     #TASK_FLAG_RESTART_ON_IDLE_RESUME       "+Str(RTask_GetFlags()&#TASK_FLAG_RESTART_ON_IDLE_RESUME)
        Debug "     #TASK_FLAG_SYSTEM_REQUIRED              "+Str(RTask_GetFlags()&#TASK_FLAG_SYSTEM_REQUIRED)
    Wend
  EndIf
;}
;-Displays the property pages of a task For editing
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Task Example.job"
        RTask_LaunchPropertyPage()
      EndIf
    Wend
  EndIf
;}

;-- Triggers
;-Creates a New Trigger
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Task Example.job"
        Debug RTask_CreateTrigger_AtLogon(Date(), AddDate(Date(), #PB_Date_Year, 1))
        Debug RTask_CreateTrigger_AtSystemStart(Date(), AddDate(Date(), #PB_Date_Year, 1))
        Debug RTask_CreateTrigger_Daily(Date(), AddDate(Date(), #PB_Date_Year, 1),2)
        Debug RTask_CreateTrigger_MonthlyDate(Date(), AddDate(Date(), #PB_Date_Year, 1),5, #TASK_JANUARY|#TASK_MARCH|#TASK_MAY|#TASK_JULY|#TASK_SEPTEMBER|#TASK_NOVEMBER)
        Debug RTask_CreateTrigger_MonthlyDow(Date(), AddDate(Date(), #PB_Date_Year, 1), #TASK_FIRST_WEEK, #TASK_MONDAY,#TASK_JANUARY|#TASK_MARCH|#TASK_MAY|#TASK_JULY|#TASK_SEPTEMBER|#TASK_NOVEMBER)
        Debug RTask_CreateTrigger_Once(Date(), AddDate(Date(), #PB_Date_Year, 1))
        Debug RTask_CreateTrigger_OnIdle(Date(), AddDate(Date(), #PB_Date_Year, 1))
        Debug RTask_CreateTrigger_Weekly(Date(), AddDate(Date(), #PB_Date_Year, 1),2, #TASK_WEDNESDAY)
      EndIf
    Wend
  EndIf
;}
; Get properties of a Trigger
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Task Example.job"
        For Inc_a = 0 To RTask_GetTriggerCount() -1
          Debug RTask_GetTriggerString(Inc_a)
          Debug "---------------------------"
          Debug RTask_GetTrigger_BeginYear(Inc_a)
          Debug RTask_GetTrigger_BeginMonth(Inc_a)
          Debug RTask_GetTrigger_BeginDay(Inc_a)
          Debug RTask_GetTrigger_EndYear(Inc_a)
          Debug RTask_GetTrigger_EndMonth(Inc_a)
          Debug RTask_GetTrigger_EndDay(Inc_a)
          Debug RTask_GetTrigger_StartHour(Inc_a)
          Debug RTask_GetTrigger_StartMinute(Inc_a)
          Debug RTask_GetTrigger_MinutesDuration(Inc_a)
          Debug RTask_GetTrigger_MinutesInterval(Inc_a)
          Debug RTask_GetTrigger_HasEndDate(Inc_a)
          Select RTask_GetTrigger_Type(Inc_a)
            Case #TASK_TIME_TRIGGER_DAILY
              Debug RTask_GetTrigger_Daily_DaysInterval(Inc_a)
            Case #TASK_TIME_TRIGGER_WEEKLY
              Debug RTask_GetTrigger_Weekly_WeeksInterval(Inc_a)
              Debug RTask_GetTrigger_Weekly_DaysOfTheWeek(Inc_a)
            Case #TASK_TIME_TRIGGER_MONTHLYDATE
              Debug RTask_GetTrigger_MonthlyDate_Days(Inc_a)
              Debug RTask_GetTrigger_MonthlyDate_Months(Inc_a)
            Case #TASK_TIME_TRIGGER_MONTHLYDOW
              Debug RTask_GetTrigger_MonthlyDow_WhichWeek(Inc_a)
              Debug RTask_GetTrigger_MonthlyDow_DaysOfTheWeek(Inc_a)
              Debug RTask_GetTrigger_MonthlyDow_Months(Inc_a)
          EndSelect
          Debug "=========================================="
        Next
      EndIf
    Wend
  EndIf
;}
; Get Trigger Strings 	
;{
  If RTask_ExamineTasks()= #S_OK
    While RTask_NextTask() = #S_OK
      If RTask_GetJobFileName() ="Task Example.job"
        For Inc_a = 0 To RTask_GetTriggerCount() -1
          Debug RTask_GetTriggerString(Inc_a)
        Next
      EndIf
    Wend
  EndIf
;}


; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 162
; FirstLine = 94
; Folding = 9v0----
; EnableUnicode
; SubSystem = UserLibUnicode